#include "Appevent.ch"
#include "Common.ch"
#include "Font.ch"
#include "Xbp.ch"
#include 'gra.ch'

#define DATAPATH            "E:\opt_data\opt_dbfs\"


#pragma Library( "XppUi2.lib" )

#define  xbeP_End           xbeP_User + 100

  #xtrans  CenterPos( <aSize>, <aRefSize> ) => ;
         { Int( (<aRefSize>\[1] - <aSize>\[1]) / 2 ) ;
         , Int( (<aRefSize>\[2] - <aSize>\[2]) / 2 ) }


#define xbeUser_Eval   xbeP_User + 1    /// 134217728+1 =134217729

PROCEDURE AppSys
LOCAL oDlg
  LOCAL asize :=   { 790, 600 }
  LOCAL apos

SET CHARSET TO ANSI
SET COLLATION TO GERMAN

oDlg := XbpDialog():new( , , { 0, 0 },aSize, , .F. )
   oDlg:taskList := .T.
   oDlg:border   := XBPDLG_SIZEBORDER
   oDlg:title    := "MY_Test Sample"
   oDlg:drawingArea:colorBG:= XBPSYSCLR_APPWORKSPACE
   odlg:drawingArea:clipChildren:= .T.
   oDlg:create()
//   AppMenu( oDlg:menuBar() )
   oDlg:setFrameState( XBPDLG_FRAMESTAT_NORMALIZED )//MAXIMIZED )
   oDlg:close    := {|uNil, uNil2, obj| PostAppEvent( xbeP_End,,, obj ) }
   SetAppWindow( oDlg )
   SetAppFocus( oDlg )
   odlg:minSize := {400,200}
     CenterControl(odlg)
 RootWindow( oDlg )


RETURN


**************
PROCEDURE Main
**************
   LOCAL nEvent, mp1, mp2, oXbp
    SET CHARSET TO ansi
 SET COLLATION TO  GERMAN

  Tdialog()

   nEvent := 0
   DO WHILE nEvent <> xbeP_End
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
        IF nEvent == xbeUser_Eval
          IF  oXbp:isDerivedFrom( "XbpBrowse" )
               Eval( mp1,oXbp )  // mp1 Codeblock wird an oxbp bergben
           ELSE
            Eval( mp1, oXbp)
          ENDIF
       ELSE



     // if oxbp :isderivedfrom("XbpMLE")
    // msgBox("FromScrollbar")
      //    endif
      oXbp:handleEvent( nEvent, mp1, mp2 )
      ENDIF
   ENDDO
   QUIT
RETURN

 * Routine zur Abfrage des Anwendungsfensters
 */
FUNCTION RootWindow( oDlg )
   STATIC soDialog
   IF PCount() > 0
      soDialog := oDlg
   ENDIF
RETURN soDialog

 #Include "Dmlb.ch"
#Include "FoxDbe.ch"
#Include "CdxDbe.ch"
#Include "NtxDbe.ch"
#Include "DbfDbe.ch"
#Include "SdfDbe.ch"
#Include "DelDbe.ch"


***********
Proc DbeSys()
***********
* Load and build all DBE's
Local x

Local aDbes:={{"DBFDBE", .T.}, ;
              {"NTXDBE", .T.}, ;
              {"CDXDBE", .T.}, ;
              {"DELDBE", .F.}, ;
              {"SDFDBE", .F.}, ;
              {"FOXDBE", .T.}}

Local aBuild :={{"DBFNTX", 1, 2}, ;
                {"DBFCDX", 1, 3}, ;
                {"FOXCDX", 6, 3}, ;
                {"FOXNTX", 6, 2}, ;
                {"SDFNTX", 5, 2}, ;
                {"SDFCDX", 5, 3}, ;
                {"DELNTX", 4, 2}, ;
                {"DELCDX", 4, 3}}
        SET COLLATION TO GERMAN
Begin Sequence

   // load DBE's
   For x:=1 To Len(aDbes)

         If !DbeLoad(aDbes[x][1], aDbes[x][2])
            MSGBOX(aDbes[x][1]+" DBE not loaded")
         EndIf

   Next x

   // build database engines
   For x:=1 To Len(aBuild)

      If !DbeBuild(aBuild[x][1], aDbes[aBuild[x][2]][1], aDbes[aBuild[x][3]][1])
        MSGBOX(aBuild[x][1]+" DBE not built")
      EndIf

   Next x

End
       DbeSetDefault( "FOXCDX" )
Return


